## revpi-tools 4.5.4

=== CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2022-2025 KUNBUS GmbH

cmake_minimum_required(VERSION 3.13)

project(revpi-tools LANGUAGES C)

include(GNUInstallDirs)

option(ENABLE_TESTS "Build and enable running tests" OFF)

configure_file(Kyuafile Kyuafile COPYONLY)

add_subdirectory(examples-watchdog)
add_subdirectory(firstboot)
add_subdirectory(revpi-config)
add_subdirectory(revpi-factory-reset)
add_subdirectory(tools)

if(ENABLE_TESTS)
	enable_testing()

	find_program(kyua_exec NAMES kyua REQUIRED)
	find_program(atf_sh_exec NAMES atf-sh REQUIRED)
	add_test(
		NAME kyua
		COMMAND sh -c "kyua test --kyuafile Kyuafile --build-root ${CMAKE_CURRENT_BINARY_DIR}; \
			RC=$?; \
			kyua report-junit --output report.xml; \
			exit $RC"
	)
	add_subdirectory(tests)
endif(ENABLE_TESTS)

=== examples-watchdog/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2023-2024 KUNBUS GmbH

add_executable(patch_eeprom patch_eeprom.c)

target_link_libraries(patch_eeprom ftdi1)
include(GNUInstallDirs)

install(TARGETS patch_eeprom
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/revpi-tools/
)

install(FILES README patch_eeprom.c enable_relay_watchdog.py disable_relay_watchdog.py revpi-connect-watchdog.sh
  DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

=== firstboot/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2023-2025 KUNBUS GmbH

include(FindPkgConfig)
pkg_check_modules(SYSTEMD REQUIRED "systemd")
pkg_get_variable(SYSTEMD_SYSTEMUNITDIR "systemd" "systemdsystemunitdir")

configure_file(resize-fs.sh resize-fs.sh COPYONLY)

install(PROGRAMS resize-fs.sh
  DESTINATION ${CMAKE_INSTALL_DATADIR}/revpi/firstboot/
)

install(FILES revpi-firstboot-resize-fs.service
  DESTINATION ${SYSTEMD_SYSTEMUNITDIR}
)

install(PROGRAMS create-ssh-host-keys.sh
  DESTINATION ${CMAKE_INSTALL_DATADIR}/revpi/firstboot/
)

install(FILES revpi-firstboot-create-ssh-host-keys.service
  DESTINATION ${SYSTEMD_SYSTEMUNITDIR}
)

=== revpi-config/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2023-2024 KUNBUS GmbH

install(PROGRAMS revpi-config
  DESTINATION ${CMAKE_INSTALL_BINDIR}/
)

set(MAN_PAGE_1 revpi-config.1)

add_custom_target(
  ${MAN_PAGE_1} ALL
  COMMAND scdoc < ${CMAKE_CURRENT_SOURCE_DIR}/${MAN_PAGE_1}.scd > ${CMAKE_CURRENT_BINARY_DIR}/${MAN_PAGE_1}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${MAN_PAGE_1}.scd
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${MAN_PAGE_1}
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/
)

=== revpi-factory-reset/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2022-2025 KUNBUS GmbH

set(DATADIR ${CMAKE_INSTALL_FULL_DATADIR})
set(SYSCONFDIR ${CMAKE_INSTALL_FULL_SYSCONFDIR})
set(SBINDIR ${CMAKE_INSTALL_FULL_SBINDIR})

configure_file(
  revpi-factory-reset.in
  revpi-factory-reset
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  @ONLY
)

configure_file(
  revpi-factory-reset.sh.in
  revpi-factory-reset.sh
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  @ONLY
)

configure_file(
	revpi-functions
	revpi-functions
	COPYONLY
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/revpi-functions
  DESTINATION ${CMAKE_INSTALL_DATADIR}/revpi/
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/revpi-factory-reset
  DESTINATION ${CMAKE_INSTALL_SBINDIR}/
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/revpi-factory-reset.sh
  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/profile.d/
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

set(MAN_PAGE_8 revpi-factory-reset.8)

add_custom_target(
  ${MAN_PAGE_8} ALL
  COMMAND scdoc < ${CMAKE_CURRENT_SOURCE_DIR}/${MAN_PAGE_8}.scd > ${CMAKE_CURRENT_BINARY_DIR}/${MAN_PAGE_8}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${MAN_PAGE_8}.scd
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${MAN_PAGE_8}
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/
)

=== tests/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2025 KUNBUS GmbH

set(copy_files
	Kyuafile
	resize_fs_test
	factory_reset_test
	test_env.sh
)

foreach(file IN LISTS copy_files)
	configure_file(${file} ${file} COPYONLY)
endforeach()

=== tools/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2022-2024 KUNBUS GmbH

set(DATADIR ${CMAKE_INSTALL_FULL_DATADIR})

configure_file(
  revpi-set-mac.in
  revpi-set-mac
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  @ONLY
)

install(PROGRAMS
  lan743x-set-mac lan78xx-set-mac lan95xx-set-mac ks8851-set-mac ${CMAKE_CURRENT_BINARY_DIR}/revpi-set-mac
  DESTINATION ${CMAKE_INSTALL_SBINDIR}/
)

set(MAN_PAGES_8 ks8851-set-mac.8 lan743x-set-mac.8 lan78xx-set-mac.8 lan95xx-set-mac.8 revpi-set-mac.8)

foreach(man_page IN LISTS MAN_PAGES_8)
  add_custom_target(
    ${man_page} ALL
    COMMAND scdoc < ${CMAKE_CURRENT_SOURCE_DIR}/${man_page}.scd > ${CMAKE_CURRENT_BINARY_DIR}/${man_page}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${man_page}.scd
  )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${man_page}
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/
  )
endforeach()

set(EEPROM_FILES lan9514 lan7800 lan743x)
find_program(XXD NAMES xxd REQUIRED)

foreach(file IN LISTS EEPROM_FILES)
  add_custom_target(
    ${file}.bin ALL
    COMMAND ${XXD} -r ${CMAKE_CURRENT_SOURCE_DIR}/${file}.hex ${CMAKE_CURRENT_BINARY_DIR}/${file}.bin
    DEPENDS ${XXD} ${CMAKE_CURRENT_SOURCE_DIR}/${file}.hex
  )

  install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${file}.bin
    DESTINATION ${CMAKE_INSTALL_DATADIR}/revpi
  )
endforeach()

# vim:et sw=2

=== debian/changelog ===
revpi-tools (4.5.4-1+deb12+1) bookworm; urgency=medium

  [ Thomas Böhler ]
  * fix(resize-fs): remove race condition with /tmp

 -- Ramiro Gsponer <r.gsponer@kunbus.com>  Mon, 29 Sep 2025 22:20:12 +0200

revpi-tools (4.5.3-1+deb12+1) bookworm; urgency=medium

  [ Ramiro Gsponer ]
  * fix: replace parted dependency with growpart

  [ Thomas Böhler ]
  * fix(firstboot): split service, fix ordering
  * fix(resize-fs): use growpart for resizing

  [ Ramiro Gsponer ]
  * fix(resize-fs): run resize-fs after local-fs

 -- Ramiro Gsponer <r.gsponer@kunbus.com>  Tue, 23 Sep 2025 11:06:36 +0200

revpi-tools (4.5.2-1+deb12+1) bookworm; urgency=medium

  * fix(revpi-config): don't let Bluetooth toggle WLAN

 -- Thomas Böhler <t.boehler@kunbus.com>  Mon, 01 Sep 2025 15:02:27 +0200

revpi-tools (4.5.1-1+deb12+1) bookworm; urgency=medium

  * fix(factory-reset): check first if ran before
  * test(factory-reset): minimal output if run before
  * fix(revpi-config): update NetworkManager state
  * feat(revpi-config): check if WLAN country is set

 -- Thomas Böhler <t.boehler@kunbus.com>  Mon, 11 Aug 2025 14:59:17 +0200

revpi-tools (4.5.0-1+deb12+1) bookworm; urgency=medium

  [ Thomas Böhler ]
  * build: failed tests fail the CMake tests as well
  * feat(factory-reset): prepare for tests
  * test(factory-reset): add HAT EEPROM test
  * fix(factory-reset): Exit early if flag set
  * build: copy revpi-functions to builddir
  * test(factory-reset): add test for hostname prefix
  * test(factory-reset): skip if state file present
  * test(factory-reset): test for default hostname
  * test(factory-reset): check for created state file

  [ Ramiro Gsponer ]
  * feat: Add function to set WiFi country code
  * feat: Use global CMDLINE variable for path
  * feat: Add get_wifi_country function
  * fix: Update wifi country settings functions
  * revert: "feat: Add function to set WiFi country code"

  [ Marc Kittner ]
  * feat: Remove sudoers rule for revpi-factory-reset
  * test(factory-reset): add test to rm sudoers file

  [ Thomas Böhler ]
  * test(factory-reset): remove missing sudoers file

 -- Thomas Böhler <t.boehler@kunbus.com>  Tue, 29 Jul 2025 15:42:47 +0200

revpi-tools (4.4.1-1+deb12+1) bookworm; urgency=medium

  [ Sven Sager ]
  * fix(firstboot): Ensure cache is written to disk after ssh key generation

 -- Thomas Böhler <t.boehler@kunbus.com>  Fri, 24 Jan 2025 10:46:29 +0100

revpi-tools (4.4.0-1+deb12+1) bookworm; urgency=medium

  [ Sven Sager ]
  * fix(firstboot): Add dependency to reboot.target in unit file
  * fix(factory-reset): Write error and warning messages to stderr

  [ Thomas Böhler ]
  * build: integrate kyua testing into CMake
  * fix(factory-reset): give timeout more context
  * refactor(set-mac): add usage function
  * feat(set-mac): print usage on wrong device type
  * fix(set-mac): compute datadir
  * fix(factory-reset): compute datadir and sysconfdir
  * build: use CMAKE_CURRENT_{SOURCE,BINARY}_DIR
  * build: install factory-reset files with good perms
  * build: loop over all eeprom hex files
  * fix(set-mac): quote expanded variables

  [ Sven Sager ]
  * fix(firstboot): Combine first boot jobs in the firstboot.service file
  * fix(firstboot): Execute tasks in the right order in boot process

  [ Thomas Böhler ]
  * refactor(factory-reset): rewrite man page in scdoc
  * doc(factory-reset): rewrite man page
  * feat(factory-reset): allow custom hostname prefix
  * doc(factory-reset): mention custom hostname prefix
  * build: install revpi-factory-reset.8 from bindir

 -- Thomas Böhler <t.boehler@kunbus.com>  Thu, 16 Jan 2025 11:48:28 +0100

revpi-tools (4.3.1-1+deb12+1) bookworm; urgency=medium

  * doc(revpi-set-mac): list device types in man page
  * doc(revpi-config): improve SYNOPSIS readability
  * doc(man-pages): underline replaceable text
  * doc(revpi-set-mac): add FILES section
  * fix(lan743x): expand binary to 512 bytes

 -- Thomas Böhler <t.boehler@kunbus.com>  Tue, 26 Nov 2024 14:31:00 +0100

revpi-tools (4.3.0-1+deb12+1) bookworm; urgency=medium

  [ Ahmad Arabi Katbi ]
  * feat!: Remove perf-governer
  * feat!: Remove downclock-cpu for clock handling
  * doc(manpage): Convert manpage to scdoc format

  [ Nicolai Buchwitz ]
  * fix: Simplify bluetooth status detection

  [ Thomas Böhler ]
  * fix(deb): add dphys-swapfile to suggests

  [ Nicolai Buchwitz ]
  * feat(revpi-config): Simplify detection of Connect
  * feat(revpi-config): Add support for Connect 5

 -- Sven Sager <s.sager@kunbus.com>  Mon, 11 Nov 2024 09:29:40 +0100

revpi-tools (4.2.2-1+revpi12+1) bookworm; urgency=medium

  * fix(pibridge): Move files to -base-files
  * feat(deb): Break on revpi-base-files < 0.4.0
  * fix(deb): Depend on raspi-utils

 -- Nicolai Buchwitz <n.buchwitz@kunbus.com>  Thu, 11 Jul 2024 13:41:29 +0200

revpi-tools (4.2.1-1+revpi12+1) bookworm; urgency=medium

  [ Ramiro Gsponer ]
  * fix(factory-reset): remove dependency for user pi
  * chore: Update copyright date
  * chore(factory-reset): Update factory reset path

  [ Thomas Böhler ]
  * fix(pibridge): pibridge.conf moves to base-files
  * feat(deb): Break on revpi-base-files < 0.3.0

 -- Thomas Böhler <t.boehler@kunbus.com>  Fri, 28 Jun 2024 09:57:05 +0200

revpi-tools (4.2.0-1+revpi12+1) bookworm; urgency=medium

  [ Thomas Böhler ]
  * fix(deb): Mention present parts in description
  * doc(deb): Update copyright years
  * ci: Add commit linting
  * ci: udev is no longer needed to build revpi-tools
  * fix(factory-reset): Make scripts executable
  * doc: Rewrite ks8851-set-mac(8) in scdoc syntax
  * build: Install man pages in loop
  * doc: Rewrite pibridge-shutdown(8) in scdoc syntax
  * doc: Add man page for lan743x-set-mac
  * doc: Add man page for lan78xx-set-mac
  * doc: Add man page for lan95xx-set-mac
  * doc: Add man page for revpi-set-mac
  * ci: Add scdoc dependency for building

  [ Philipp Rosenberger ]
  * fix: Install lan743x.bin

  [ Thomas Böhler ]
  * feat: Make resize-fs.sh testable


=== debian/control ===
Source: revpi-tools
Section: electronics
Priority: optional
Maintainer: KUNBUS GmbH <support@kunbus.com>
Rules-Requires-Root: binary-targets
Homepage: https://revolutionpi.com/
Vcs-Browser: https://gitlab.com/revolutionpi/revpi-tools
Vcs-Git: https://gitlab.com/revolutionpi/revpi-tools.git -b debian/bookworm
Build-Depends:
  cmake,
  debhelper-compat (= 13),
  dh-python,
  libftdi1-dev,
  pkg-config,
  python3-all,
  scdoc,
  systemd,
  xxd
Standards-Version: 4.6.2

Package: revpi-tools
Architecture: any
Multi-Arch: foreign
Depends:
  cloud-guest-utils,
  e2fsprogs,
  ethtool,
  iproute2,
  raspi-utils,
  piserial (>= 3.0.0),
  python3-ftdi1,
  sudo,
  whiptail,
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends}
Suggests:
  revpi-sos-report,
  avahi-daemon,
  dphys-swapfile,
Replaces: revpi-webstatus (<< 1:2.1.0)
Breaks:
  piserial (<< 3.0.0),
  revpi-webstatus (<< 1:2.1.0),
  revpi-base-files (<< 0.4.0),
Description: Revolution Pi tools
 Assorted tools and support files for Revolution Pi products:
 .
  * scripts to enable/disable the relay watchdog on the RevPi Connect
  * sosreport plugin to collect Revolution Pi related system information
    which can be submitted to Kunbus as part of a support request
  * revpi-factory-reset is used to finalize a RevPi after the factory end
    of line test
 .
 Revolution Pi is a set of IoT products based on the Raspberry Pi and
 geared towards industrial usage.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with python3
